(function($){
    var PlgSysExternalLinkWarning = function(options) {
        var root = this;
        var vars = {
            hostname:null,
            options: {
                sitename:false,
                warningexcludeclasses:'{"classes":[]}',
                warningexcludedomains:'{"domains":[]}',
                uselinkicon:false,
                linkicon:'',
                linkiconexcludeclasses:'{"classes":[]}'
            }
        }
        
        this.construct = function(options) {
            var parse = [];
            $.each(options,function(index,value){ 
                vars.options[index]=(parse.indexOf(index)==-1)?value:JSON.parse(value); 
            });
            vars.hostname = getHostname(window.location.href);
            var links = findLinks();
        }
        
        this.showVars = function() {
            return vars;
        }
        
        var getHostname = function(url){
            var s = document.createElement("a");
            s.href = url;
            return s.hostname;
        }
        
        var findLinks = function() {
            var links = [];
            var domain, proc, classes;
            $.each($('a'),function(i,el){
                proc=true;
                domain = getHostname(el.href);
                classes = el.className.split(/\s+/);
                if(
                        el.href.substring(0,10) !== 'javascript' &&
                        domain !== vars.hostname
                ) {
                    links.push(el);
                    $(el).click(function(e){
                        e.stopPropagation();
                        e.preventDefault();
                        linkWarning(el.href);
                    });
                }
            });
            return links;
        }
        
        var arrayIntersect = function(a1,a2){
            return $.map(a1,function(a){return $.inArray(a, a2) < 0 ? null : a;});
        }
        
        var linkWarning = function(url){
            var desthost = getHostname(url);
            if(confirm(Joomla.JText._('PLG_SYS_EXTERNALLINKWARNING_WARNINGTEXT').replace('{domain}',vars.hostname).replace('{destdomain}',desthost).replace('{sitename}',vars.options.sitename))) {
                window.open(url,'_blank');
            }
        }
        
        this.construct(options);
    }
    $(document).ready(function(){
        window.plg_system_externallinkwarning = new PlgSysExternalLinkWarning(window.plg_system_externallinkwarning_options);
    });
})(jQuery);